// R_VAR.CPP : Implementierung Variablen, Konstante f. Radio
// G. TAMM, DF9ZO 1999-2007
//-------------------------
#ifndef _R_VAR_H_
  #include "R_VAR.H"
#endif
//+Specials++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
CFrameWnd* PtrToRemDisp;
//+Globale Variablen+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
char		 AppName[]	  		  ="TaICOM by DF9ZO",
			 InfoStr[]	  		  ="TaICOM by DF9ZO, V 4.32 (Build 04.03.2007)\n"
                                   "Copyright 1991-2007 by G. TAMM, DF9ZO",
             CmdFName[Fl]         ="",
			 F_Env[]              ="TaICOM.INI",
             F_Help[]             ="TaICOM.TXT",
             F_Log[]              ="TaICOM.LOG",
             StatStr[150]         ="Ready",
			 ComStatStr  [150]    ="",
             RadioStatStr[150]    ="";
//-----------------------------------------------------------------------------
int          Win_X                =0,
             Win_Y                =0,
             Win_W                =620,
             Win_H                =520;//470
int          Win_XIOpos           =0,
             Win_YIOpos           =0;
long         IdleCount            =0;   
//-----------------------------------------------------------------------------
COLORREF     red	              =RGB(255,0,0),
             black                =RGB(0,0,0),
             blue	              =RGB(0,0,255),
             green                =RGB(0,128,0),
             magenta              =RGB(255,0,255);
//-----------------------------------------------------------------------------
int	         COM_PORT             =1;
int			 COM_BAUD             =8;
int          COM_DATA             =4;
int          COM_STOP             =0;
int          COM_PARI             =4;
int          COM_PROT             =3;
int          COM_Poll_Mode        =1;
int          COM_Poll_Interval    =10;
int          COM_IsPolling        =0;
UINT         COM_Timer_ID         =0;
//-----------------------------------------------------------------------------
int 		 REMO				  =0;
int 		 RemDisp_UPD          =0;
int			 SCAN				  =0;
int          Radio_Num            =0;                
//-----------------------------------------------------------------------------
char         Fact_s[RStrLf]	      ="10.000,000";
char         Fdef_s[RStrLf]	      ="10.000,000";  //R_Lib_Init()
char         Flas_s[RStrLf]	      ="10.000,000";
char         Fold_s[RStrLf]	      ="10.000,000";
unsigned int Fact_n               =10000000;
unsigned int Fmin_n        	      =0;
unsigned int Fmax_n        	      =0;
//-----------------------------------------------------------------------------
char         SFact_s[RStrLf]	  =".025,000";
char		 SFdef_s[RStrLf]	  =".025,000";    //R_Lib_Init()
unsigned int SFact_n              =25000;
//-----------------------------------------------------------------------------
extern char  OFact_s[RStrLf]      =".600,000";
extern char	 OFdef_s[RStrLf]      =".600,000";    //R_Lib_Init()
extern int   OFact_n              =600000;
//-----------------------------------------------------------------------------
char         Mact_s[RStrLm]       ="AM";
char		 Mdef_s[RStrLm]       ="AM";          //R_Lib_Init
char		 Mlas_s[RStrLm]       ="AM";          //R_Lib_Init
int			 Mact_n			 	  =4;			  //Voreinstellung AM
int			 Mlas_n               =4;

int          MaxMOsLe             =0;
char         MOs[MaxMOs][RStrLm]  ={"USB"   ,"LSB",
									"FM"    ,"FMW",
                                    "AM"    ,"CW" ,
                                    "RTTY"  ,"CW-R",
                                    "RTTY-R","SKI"};
//-----------------------------------------------------------------------------
char         FIact_s[RStrLm]	  ="-";
int 		 FIact_n		 	  =0;             //Voreinstellung Normal
int 		 FIlas_n              =0; 

int          MaxFIsLe             =0;
char         FIs[MaxFIs][RStrLm]  ={"-","N","W"};
//-----------------------------------------------------------------------------
int			 ANTsw                =0;

int 		 ATTsw		 		  =0;
char         ATT_li_s[4][2]       ={"-","1","2","3"};

int			 PAMPsw               =0;

int			 AGCsw                =2;

int          DUPsw                =0;
   
int          VFOsw                =0;

int          VMsw                 =0;

int			 NBsw                 =0;
int			 NBlev_n              =128;
int			 NBwid_n              =128;

int			 NRsw                 =0;
int          NRlev_n              =72;

int			 ANFsw                =0;

int 		 SQLlev_n             =0;
int 		 SQL_oc               =0;
int	 		 SMlev_n              =0;
char		 SMlev_s[20]          ="0";
int			 SM_li_n[15]          ={20,40,60,80,100,120,140,160,180,
                                    200,210,220,230,240,250};
char		 SM_li_s[15][8]       ={"S1","S2","S3","S4","S5","S6","S7",
                                    "S8 ","S9",
                                    "S9+10dB","S9+20dB","S9+30dB","S9+40dB",
                                    "S9+50dB","S9+60dB"};
int	 		 SM_sel               =1;
int	 		 SQLSM_cont           =0;	

int 		 AFlev_n              =0;

int 		 RFlev_n              =255;

int 		 PBTH_n               =128;
int 		 PBTL_n               =128;

int 		 CWSPEED_n            =0;
	
int          TXPWR_n              =0;
int          TXPWR_tune           =27;

int   		 RTTY_TPFsw_n         =0;
int          RTTY_KPsw_n          =0;
int          RTTY_MFsw_n          =2;
int          RTTY_SHsw_n          =0;
int          RTTY_RXDECsw_n       =0;

char         MEMtxt_s[100]        ="";            
//-----------------------------------------------------------------------------
const char   RadAdds_s[7][7]      ={">SF=" ,">OF=" ,
                                    ">FI=" ,">ATT=",
                                    ">DUP=",">PAMP=",
                                    ">TXT="};
//+Spezifika ICOM CI-V - Bus+++++++++++++++++++++++++++++++++++++++++++++++++++    
//+TIRadioData_IB++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
TIRadioData_IB IRADIO_IB[IRadios_IB_Max]=
{
{"IC-7000 HF-UHF",				  //Titel
 //----------
 "145.350,000",                   //F def.
 ".030,000","440.000,000",        //Fmin, Fmax
 0,"SMC_IC7000.SMC",              //SQL_SH, S-M Konversion
 //----------
 "70",5,                          //ICOM-Adr. (String, hex), Datalength (4 oder 5)
 1,                               //HW-/DSP-Filter
 {"","","",                       //SSB  Normal,Narrow,Wide
  "","","",                       //FM
  "" ,"" ,"",                     //FMW
  "","","",                       //AM
  "","","",                       //CW
  "","",""},                       //RTTY
 //REM-------
 "145.350,000",                   //F act.
 2,0,                             //Modeindex, FilterIndex
 ".025,000",".600,000",           //F-Step, F-Offset
 //SCAN------
 "145.000,000","145.975,000",     //F low/high
 ".025,000",                      //F-Step
 2,0,                             //Modeindex, FilterIndex
 50,                              //Step-Delay
 2,                               //Mode Scanstop
 1000,100,                        //M2Del, M3Lev
 1,1                              //Write Spec, Longterm Spec     
},
{"IC-746 HF-VHF",
 //----------
 "145.350,000",
 ".030,000","174.000,000",
 1,"SMC_IC746.SMC",
 //----------
 "56",5,
 0,
 {"1","2","" , 
  "1","2","" , 
  "" ,"" ,"" , 
  "1","2","" ,
  "1","2","" ,
  "1","2","" },
 //----------
 "145.350,000",
 2,0,
 ".025,000",".600,000",
 //----------
 "","",
 ".001,000",
 4,0, 
 50,
 2,
 1000,100,
 1,1       
},
{"IC-706 HF-UHF",
 //----------   
 "145.350,000",
 ".030,000","470.000,000",
 0,"SMC_IC706.SMC",
 //----------
 "58",5,
 0,
 {"1","2","" , 
  "1","2","" , 
  "" ,"" ,"" , 
  "1","2","" ,
  "2","3","1", 
  "2","3","1"},
 //----------
 "145.350,000",
 2,0,
 ".025,000",".600,000",
 //----------
 "","",
 ".001,000",
 4,0, 
 50,
 2,
 1000,100,
 1,1      
},
{"",
 //----------   
 "",
 "","",
 1,"",
 //----------
 "",5,
 0,
 {"","","" , 
  "","","" , 
  "" ,"" ,"" , 
  "","","" ,
  "","","",
  "","",""},
 //----------
 "",
 2,0,
 "","",
 //----------
 "","",
 ".001,000",
 4,0, 
 50,
 2,
 1000,100,
 1,1      
}
};

int          IRadio_IB_Adr_n      =0;
int          IRadio_IB_Da_n       =0;
int 		 IRadio_IB_SQL_n      =0;
int          IRadio_IB_Conf       =0;
int          IRadio_IB_CmdDel     =20;//********
int          IRadio_IB_DSP_Fi     =0;
int          IRadio_IB_Fi_n[18];
//-----------------------------------------------------------------------------
int			 ScLiInd              =0,
             ScLiNum              =0;

int			 ScOpMo               =0,
             ScOpMoFrFile         =0,
             ScStopMo             =0, 
             ScIsRu               =0,
             ScIsSta              =0,
             ScIsSto              =0,
             ScIsResta            =0;

char         ScLoF_s[RStrLf]	  ="144.400,000",
             ScHiF_s[RStrLf]      ="145.975,000";
unsigned int ScLoF_n              =0,
			 ScHiF_n              =0;

char		 ScStepDel_s[6]		  ="20",
			 ScM2Del_s[6]         ="1000",
             ScM3Lev_s[6]         ="100";
int			 ScStepDel_n          =20,
			 ScM2Del_n            =1000,
             ScM3Lev_n            =100;

char         ScStr1[200]          ="",
             ScStr2[200]          ="",
             ScTime1[30]          ="",
             ScTime2[30]          ="";

int 		 ScWrSpec             =0,
             ScLtSpec             =0;

char         F_ScMScanFi[Fl]      ="EXAMPLE.FRE",
             F_ScLibFi[Fl]        ="EXAMPLE.LIB";   
             
TScan ScAr;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+Messages++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
char         msg00[]              ="Feature NOT implemented",
             msg01[]			  ="Memory operations done",
             msg02[]			  ="",
     		 msg03[]			  ="ERROR\n\n"
                                   "- Radio does not respond\n"
                                   "- Radio not equipped with this function\n\n",
             msg04[]			  ="ERROR\n\n"
                                   "Feature ONLY for Radios with Datalength=5",
             msg05[]			  ="ERROR\n\n"
                                   "Feature ONLY for Radios with DSP-Filters",
             //-----------------     
     		 scmsg00[]			  ="Select SCAN, M-SCAN or load a Library",
     		 scmsg01[]			  ="ERROR M-Scan/Library:\n\n"
                                   "No/Bad File selected\n",
     		 scmsg02[]			  ="ERROR Scan:\n\n"
                                   "- LoF >= HiF\n"
                                   "- LoF or HiF out of range of radio\n"
                                   "- Too many scan steps\n"
                                   "- Wrong parameter format",
     		 scmsg03[]			  ="ERROR M-Scan:\n\n"
                                   "- No/Bad File\n"
                                   "- Frequencies out of range of radio\n"
                                   "- Too many scan steps\n"
                                   "- Wrong parameter format\n\n"
                                   "->Items with bad parameters modified/deleted",
             //-----------------     
     		 commsg00[]			  ="Selected COM-Port is NOT available",             
             //-----------------
             statmsg00[]          ="Ready",
             statmsg01[]          ="Configuration of Radio ",
             statmsg02[]          ="Configure/Select a Radio",
             statmsg03[]          ="Selected Radio: ",
             //ICOM CI-V - Bus--
       		 IB_msg00[]			  ="ICOM-Message",
     		 IB_msg01[]			  ="Collision on ICOM-Bus",
     		 IB_msg02[]			  ="Data OK",
             IB_msg03[]			  ="Data NOT OK",
             IB_msg04[]			  ="ERROR: Radio OFF/NOT equipped with this function";
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
char         defini01[]           ="WinX",
             defini02[]           ="WinY",
             defini03[]           ="WinW",
             defini04[]           ="WinH",
             defini05[]           ="RadioSelection",
             defini06[]           ="COM_PORT",
             defini07[]           ="COM_BAUD",
             defini08[]           ="COM_DATA",
             defini09[]           ="COM_PARI",
             defini10[]           ="COM_STOP",
             defini11[]           ="COM_PROT",
             defini12[]           ="COM_Poll_Mode",
             defini13[]           ="COM_Poll_Interval",
             defini14[]           ="Radio_TUNE-PWR",
             defini15[]           ="SQLSM_Cont",
             defini16[]           ="CmdDel";
                
char         radini01[]			  ="Radio",
             radini02[]			  ="Fdef",
	  		 radini03[]			  ="Fmin",
             radini04[]			  ="Fmax",
     		 radini05[]			  ="SQL-SH",
	  		 radini06[]           ="SMConv",
             radini07[]           ="RE_F",
	  		 radini08[]           ="RE_M",
             radini09[]			  ="RE_FI",
             radini10[]           ="RE_Fstep",
             radini11[]           ="RE_Foffs",

             radini12[]			  ="SC_LoF",
             radini13[]			  ="SC_HiF",
             radini14[]			  ="SC_Fstep",
             radini15[]			  ="SC_M",
             radini16[]			  ="SC_FI",
             radini17[]			  ="SC_StepDel",
             radini18[]			  ="SC_StopMode",
             radini19[]			  ="SC_M2Del",
             radini20[]			  ="SC_M3Lev",
             radini21[]			  ="SC_WrSpec",
             radini22[]			  ="SC_LtSpec";

char         scini01[]			  ="OpMode",
             scini02[]			  ="LoF",
             scini03[]			  ="HiF",
             scini04[]			  ="Fstep",
             scini05[]			  ="M",
             scini06[]			  ="FI",
             scini07[]			  ="StepDel",
             scini08[]			  ="StopMode",
             scini09[]			  ="M2Del",
             scini10[]			  ="M3Lev",
             scini11[]			  ="WrSpec",
             scini12[]			  ="LtSpec";             
             
char         smcini01[]           ="S1",
             smcini02[]           ="S2",
             smcini03[]           ="S3",
             smcini04[]           ="S4",
             smcini05[]           ="S5",
             smcini06[]           ="S6",
             smcini07[]           ="S7",
             smcini08[]           ="S8",
             smcini09[]           ="S9",
             smcini10[]           ="S9_10",
             smcini11[]           ="S9_20",
             smcini12[]           ="S9_30",
             smcini13[]           ="S9_40",
             smcini14[]           ="S9_50",
             smcini15[]           ="S9_60";

char         fiini01[]			  ="",
             fiini02[]			  ="",
             fiini03[]			  ="",
             fiini04[]			  ="";

char	 	 IRadio_IB_ini[21][10]={"Fi_SSB" ,"Fi_SSB_N" ,"Fi_SSB_W" ,
									"Fi_FM"  ,"Fi_FM_N"  ,"Fi_FM_W"  ,
     			  					"Fi_FMW" ,"Fi_FMW_N" ,"Fi_FMW_W" ,
     			  					"Fi_AM"  ,"Fi_AM_N"  ,"Fi_AM_W"  ,
     			  					"Fi_CW"  ,"Fi_CW_N"  ,"Fi_CW_W"  ,
     			  					"Fi_RTTY","Fi_RTTY_N","Fi_RTTY_W",
                                    "IB_Adr",//18
                                    "IB_Data", 
                                    "IB_DSP_Fi"};
//+INI-File++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int RIniFile(void)
{
 TaIniLib li;
 char     str[80],indstr[15];
 int      r,x,y;

 r=li.ReadList(F_Env);if (r == 0) return 0;//File nicht vorhanden
 //defini------------------------------------------
 li.Rint(defini01,Win_X            );
 li.Rint(defini02,Win_Y            );
 li.Rint(defini03,Win_W            );
 li.Rint(defini04,Win_H            );
 li.Rint(defini05,Radio_Num        );
 li.Rint(defini06,COM_PORT         );
 li.Rint(defini07,COM_BAUD         );
 li.Rint(defini08,COM_DATA         );
 li.Rint(defini09,COM_PARI         );
 li.Rint(defini10,COM_STOP         );
 li.Rint(defini11,COM_PROT         );
 li.Rint(defini12,COM_Poll_Mode    );
 li.Rint(defini13,COM_Poll_Interval);
 li.Rint(defini14,TXPWR_tune       );
 li.Rint(defini15,SQLSM_cont       );
 li.Rint(defini16,IRadio_IB_CmdDel );
 //radini------------------------------------------
 for (x=0;x < IRadios_IB_Max;x++)
  {
   itoa(x,indstr,10);strcat(indstr,"_");
   strcpy(str,indstr);strcat(str,radini01);li.Rstr(str,IRADIO_IB[x].Name      );
   strcpy(str,indstr);strcat(str,radini02);li.Rstr(str,IRADIO_IB[x].Fdef_s    );
   strcpy(str,indstr);strcat(str,radini03);li.Rstr(str,IRADIO_IB[x].Fmin_s    );
   strcpy(str,indstr);strcat(str,radini04);li.Rstr(str,IRADIO_IB[x].Fmax_s    );
   strcpy(str,indstr);strcat(str,radini05);li.Rint(str,IRADIO_IB[x].SQL_SH    );
   strcpy(str,indstr);strcat(str,radini06);li.Rstr(str,IRADIO_IB[x].SmConv_s  );

   strcpy(str,indstr);strcat(str,radini07);li.Rstr(str,IRADIO_IB[x].RE_Fact_s );
   strcpy(str,indstr);strcat(str,radini08);li.Rint(str,IRADIO_IB[x].RE_Mact_n );
   strcpy(str,indstr);strcat(str,radini09);li.Rint(str,IRADIO_IB[x].RE_FIact_n);
   strcpy(str,indstr);strcat(str,radini10);li.Rstr(str,IRADIO_IB[x].RE_SFact_s);
   strcpy(str,indstr);strcat(str,radini11);li.Rstr(str,IRADIO_IB[x].RE_OFact_s);

   strcpy(str,indstr);strcat(str,radini12);li.Rstr(str,IRADIO_IB[x].SC_LoF_s  );
   strcpy(str,indstr);strcat(str,radini13);li.Rstr(str,IRADIO_IB[x].SC_HiF_s  );
   strcpy(str,indstr);strcat(str,radini14);li.Rstr(str,IRADIO_IB[x].SC_SFact_s);
   strcpy(str,indstr);strcat(str,radini15);li.Rint(str,IRADIO_IB[x].SC_Mact_n );
   strcpy(str,indstr);strcat(str,radini16);li.Rint(str,IRADIO_IB[x].SC_FIact_n);
   strcpy(str,indstr);strcat(str,radini17);li.Rint(str,IRADIO_IB[x].SC_StepDel);
   strcpy(str,indstr);strcat(str,radini18);li.Rint(str,IRADIO_IB[x].SC_StopMo );
   strcpy(str,indstr);strcat(str,radini19);li.Rint(str,IRADIO_IB[x].SC_M2Del  );
   strcpy(str,indstr);strcat(str,radini20);li.Rint(str,IRADIO_IB[x].SC_M3Lev  );
   strcpy(str,indstr);strcat(str,radini21);li.Rint(str,IRADIO_IB[x].SC_WrSpec );
   strcpy(str,indstr);strcat(str,radini22);li.Rint(str,IRADIO_IB[x].SC_LtSpec );
   
   strcpy(str,indstr);strcat(str,IRadio_IB_ini[18]);li.Rstr(str,IRADIO_IB[x].IB_Adr_s );
   strcpy(str,indstr);strcat(str,IRadio_IB_ini[19]);li.Rint(str,IRADIO_IB[x].IB_Da_n  );
   strcpy(str,indstr);strcat(str,IRadio_IB_ini[20]);li.Rint(str,IRADIO_IB[x].IB_DSP_Fi);
   for (y=0;y < 18;y++)
    {
     strcpy(str,indstr);strcat(str,IRadio_IB_ini[y]);
     li.Rstr(str,IRADIO_IB[x].IB_Fi_s[y]);
     if (IRADIO_IB[x].IB_Fi_s[y][0] == '-') IRADIO_IB[x].IB_Fi_s[y][0]='\0';
    }
  }
 //------------------------------------------------
 return 1;
}
//-----------------------------------------------------------------------------
int WIniFile(void)
{
 TaIniLib li;
 char     str[80],indstr[15],radstr[15]="[RADIO_";
 int      x,y;
 //defini------------------------------------------
 li.AppStr("[WINDOW]"); 
 li.Wint(defini01,Win_X            );
 li.Wint(defini02,Win_Y            );
 li.Wint(defini03,Win_W            );
 li.Wint(defini04,Win_H            ); 
 li.Wint(defini05,Radio_Num        );
 li.Wint(defini06,COM_PORT         );
 li.Wint(defini07,COM_BAUD         );
 li.Wint(defini08,COM_DATA         );
 li.Wint(defini09,COM_PARI         );
 li.Wint(defini10,COM_STOP         );
 li.Wint(defini11,COM_PROT         );
 li.Wint(defini12,COM_Poll_Mode    );
 li.Wint(defini13,COM_Poll_Interval);
 li.Wint(defini14,TXPWR_tune       );
 li.Wint(defini15,SQLSM_cont       );
 li.Wint(defini16,IRadio_IB_CmdDel );
 //radini------------------------------------------
 li.AppStr("[Radios: ICOM CI-V - Bus]");
 for (x=0;x < IRadios_IB_Max;x++)
  {
   itoa(x,indstr,10);

   strcpy(str,radstr);strcat(str,indstr);strcat(str,"]");
   li.AppStr(str); 
   
   strcat(indstr,"_");
   strcpy(str,indstr);strcat(str,radini01);li.Wstr(str,IRADIO_IB[x].Name      );
   strcpy(str,indstr);strcat(str,radini02);li.Wstr(str,IRADIO_IB[x].Fdef_s    );
   strcpy(str,indstr);strcat(str,radini03);li.Wstr(str,IRADIO_IB[x].Fmin_s    );
   strcpy(str,indstr);strcat(str,radini04);li.Wstr(str,IRADIO_IB[x].Fmax_s    );
   strcpy(str,indstr);strcat(str,radini05);li.Wint(str,IRADIO_IB[x].SQL_SH    );
   strcpy(str,indstr);strcat(str,radini06);li.Wstr(str,IRADIO_IB[x].SmConv_s  );

   strcpy(str,indstr);strcat(str,radini07);li.Wstr(str,IRADIO_IB[x].RE_Fact_s );
   strcpy(str,indstr);strcat(str,radini08);li.Wint(str,IRADIO_IB[x].RE_Mact_n );
   strcpy(str,indstr);strcat(str,radini09);li.Wint(str,IRADIO_IB[x].RE_FIact_n);
   strcpy(str,indstr);strcat(str,radini10);li.Wstr(str,IRADIO_IB[x].RE_SFact_s);
   strcpy(str,indstr);strcat(str,radini11);li.Wstr(str,IRADIO_IB[x].RE_OFact_s);

   strcpy(str,indstr);strcat(str,radini12);li.Wstr(str,IRADIO_IB[x].SC_LoF_s  );
   strcpy(str,indstr);strcat(str,radini13);li.Wstr(str,IRADIO_IB[x].SC_HiF_s  );
   strcpy(str,indstr);strcat(str,radini14);li.Wstr(str,IRADIO_IB[x].SC_SFact_s);
   strcpy(str,indstr);strcat(str,radini15);li.Wint(str,IRADIO_IB[x].SC_Mact_n );
   strcpy(str,indstr);strcat(str,radini16);li.Wint(str,IRADIO_IB[x].SC_FIact_n);
   strcpy(str,indstr);strcat(str,radini17);li.Wint(str,IRADIO_IB[x].SC_StepDel);
   strcpy(str,indstr);strcat(str,radini18);li.Wint(str,IRADIO_IB[x].SC_StopMo );
   strcpy(str,indstr);strcat(str,radini19);li.Wint(str,IRADIO_IB[x].SC_M2Del  );
   strcpy(str,indstr);strcat(str,radini20);li.Wint(str,IRADIO_IB[x].SC_M3Lev  );
   strcpy(str,indstr);strcat(str,radini21);li.Wint(str,IRADIO_IB[x].SC_WrSpec );
   strcpy(str,indstr);strcat(str,radini22);li.Wint(str,IRADIO_IB[x].SC_LtSpec );
   
   strcpy(str,indstr);strcat(str,IRadio_IB_ini[18]);li.Wstr(str,IRADIO_IB[x].IB_Adr_s );
   strcpy(str,indstr);strcat(str,IRadio_IB_ini[19]);li.Wint(str,IRADIO_IB[x].IB_Da_n  );
   strcpy(str,indstr);strcat(str,IRadio_IB_ini[20]);li.Wint(str,IRADIO_IB[x].IB_DSP_Fi);
   for (y=0;y < 18;y++)
    {
     strcpy(str,indstr);strcat(str,IRadio_IB_ini[y]);
     if (IRADIO_IB[x].IB_Fi_s[y][0] == '\0') li.Wstr(str,"-\0");
        else li.Wstr(str,IRADIO_IB[x].IB_Fi_s[y]);
    }

  } 
 //------------------------------------------------
 li.AppStr("[Radios: ICOM RS232]");
 li.AppStr("[Radios: ICOM USB]");  
 li.WriteList(F_Env);
 return 1;
}
//+LIB-File++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int RLibFile(char *FName)
{
 TaIniLib li;
 char     indstr[20],str[50],tmpstr[6],tre=';';
 int      x,pos;

 x=li.ReadList(FName);if (x == 0) return 0;//File nicht vorhanden
 //---------------------------------
 li.Rint(scini01,ScOpMoFrFile);
 li.Rstr(scini02,ScLoF_s     );
 li.Rstr(scini03,ScHiF_s     );
 li.Rstr(scini04,SFact_s     );
 li.Rint(scini05,Mact_n      );
 li.Rstr(scini06,FIact_s     );
 li.Rint(scini07,ScStepDel_n );
 li.Rint(scini08,ScStopMo    );
 li.Rint(scini09,ScM2Del_n   );
 li.Rint(scini10,ScM3Lev_n   );
 li.Rint(scini11,ScWrSpec    );
 li.Rint(scini12,ScLtSpec    );
 //-----------------------
 ScLiNum=0;
 for (x=0;x<ScLiMax+1;x++)
  {
   if (x == ScLiMax-1) break;
   itoa(x,indstr,10);StrFiLe(indstr,'0',3);//strcat(indstr,"_val");   
   li.Rstr(indstr,str);if (str[0] == tre) break;
   //------------
   pos=StrStartToTok(str,ScAr.f[x],tre,0);
   pos=StrStartToTok(str,tmpstr,tre,pos+1);ScAr.m[x]=atoi(tmpstr);
   pos=StrStartToTok(str,tmpstr,tre,pos+1);ScAr.y[x]=atoi(tmpstr);
   //------------
   ScLiNum++;
  }
 //---------------------------------
 return 1;
}  
//-----------------------------------------------------------------------------
int WLibFile(char *FName)
{
 TaIniLib li;
 char     indstr[20],str[30],substr[10],tre[2]=";";
 int      x;
 //---------------------------------
 if (ScOpMo == 1) x=1;//SCAN
 if (ScOpMo == 2) x=2;//M-SCAN
 if (ScOpMo == 3)     //LIB
  {
   if (ScOpMoFrFile == 1) x=1;//scan in lib
   if (ScOpMoFrFile == 2) x=2;//m-scan in lib
  }
 li.Wint(scini01,x);
 li.Wstr(scini02,ScLoF_s    );
 li.Wstr(scini03,ScHiF_s    );
 li.Wstr(scini04,SFact_s    );
 li.Wint(scini05,Mact_n     );
 li.Wstr(scini06,FIact_s    );
 li.Wint(scini07,ScStepDel_n);
 li.Wint(scini08,ScStopMo   );
 li.Wint(scini09,ScM2Del_n  );
 li.Wint(scini10,ScM3Lev_n  );
 li.Wint(scini11,ScWrSpec   );
 li.Wint(scini12,ScLtSpec   );
 //-----------------------
 for (x=0;x<ScLiMax;x++)
  {
   itoa(x,indstr,10);StrFiLe(indstr,'0',3);//strcat(indstr,"_val");   
   if (ScAr.f[x][0] == '\0' || x == ScLiMax-1) {li.Wstr(indstr,tre);break;}  
   strcpy(str,ScAr.f[x]);strcat(str,tre);
   itoa(ScAr.m[x],substr,10);strcat(str,substr);strcat(str,tre);
   itoa(ScAr.y[x],substr,10);strcat(str,substr);strcat(str,tre);
   li.Wstr(indstr,str);
  }
 //---------------------------------
 li.WriteList(FName);
 return 1;
}
//+SMC-File++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int RSMCFile(char *FName)
{
 TaIniLib li;
 int      x;

 x=li.ReadList(FName);if (x == 0) return 0;//File nicht vorhanden
 //---------------------------------
 li.Rint(smcini01,SM_li_n[ 0]);
 li.Rint(smcini02,SM_li_n[ 1]);
 li.Rint(smcini03,SM_li_n[ 2]);
 li.Rint(smcini04,SM_li_n[ 3]);
 li.Rint(smcini05,SM_li_n[ 4]);
 li.Rint(smcini06,SM_li_n[ 5]);
 li.Rint(smcini07,SM_li_n[ 6]);
 li.Rint(smcini08,SM_li_n[ 7]);
 li.Rint(smcini09,SM_li_n[ 8]);
 li.Rint(smcini10,SM_li_n[ 9]);
 li.Rint(smcini11,SM_li_n[10]);
 li.Rint(smcini12,SM_li_n[11]);
 li.Rint(smcini13,SM_li_n[12]);
 li.Rint(smcini14,SM_li_n[13]);
 li.Rint(smcini15,SM_li_n[14]);
 //---------------------------------
 return 1;
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+Liste+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
List Fli;
int  FliMax;
//-----------------------------------------------------------------------------
int LiReadFile(List& li,int sel,char *fName)
{
 CStdioFile     F_In;
 CFileException F_Exc;
 const int      le=500;
 CString        str("",le);
 char           DiskL[le];

 if(!F_In.Open(fName,CFile::modeRead | CFile::typeText,&F_Exc)) 
  {
   //MessageBox(0,"ERROR file (R_VAR:LiReadFile)","",MB_ICONSTOP | MB_OK);
  }else
  {
   while (F_In.ReadString(DiskL,le-2) != 0)
    {
     StrDel_CR_LF(DiskL);
     if (sel == 0)
      {
       str=DiskL;li.push_back(str);
      }
     if (sel == 1)
      {
       if (DiskL[0] == 'M' && DiskL[1] == '_') {str=DiskL;li.push_back(str);}
      }
    }
   F_In.Close();
  }

 if (li.size() == 0) return 0;else return 1;
}
//-----------------------------------------------------------------------------
void LiRemAllElem(List& l)
{
 List::iterator iter;
 int            x;

 if (l.size() == 0) return;
 //--------------------------
 for (x=1;l.size() > 0;x++)
  {
   iter=l.begin();
   l.erase(iter);
  }
}
//-----------------------------------------------------------------------------
void LiGetElemAt(List& l,CString& dest,int pos)
{
 List::iterator iter;
 int            x;

 if (pos > (int)l.size()) {dest="";return;}
 iter=l.begin();
 for (x=1;x < pos;x++) iter++;
 dest=(*iter);
}

void LiGetElemAt(List& l,char* dest,int pos)
{
 List::iterator iter;
 CString        dstr("",500);
 int            x;

 if (pos > (int)l.size()) {dest="";return;}
 iter=l.begin();
 for (x=1;x < pos;x++) iter++;
 dstr=(*iter);strcpy(dest,LPCTSTR(dstr));
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
